/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.124 Revision 1.169
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.124 2008/07/03 05:30:54 dberkholz Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.169 2012/02/26 12:09:44 blueness Exp $
4 4
5# @ECLASS: flag-o-matic.eclass 5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# toolchain@gentoo.org 7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags 8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely 10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds. 11# and safely manage toolchain flags in their builds.
12 12
13if [[ ${___ECLASS_ONCE_FLAG_O_MATIC} != "recur -_+^+_- spank" ]] ; then
14___ECLASS_ONCE_FLAG_O_MATIC="recur -_+^+_- spank"
15
13inherit eutils toolchain-funcs multilib 16inherit eutils toolchain-funcs multilib
14 17
15################ DEPRECATED functions ################ 18# Return all the flag variables that our high level funcs operate on.
16# The following are still present to avoid breaking existing 19all-flag-vars() {
17# code more than necessary; however they are deprecated. Please 20 echo {C,CPP,CXX,CCAS,F,FC,LD}FLAGS
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you 21}
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
21#
22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
27
28 22
29# {C,CXX,F,FC}FLAGS that we allow in strip-flags 23# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed 24# Note: shell globs and character lists are allowed
31setup-allowed-flags() { 25setup-allowed-flags() {
32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
33 export ALLOWED_FLAGS="-pipe" 26 ALLOWED_FLAGS="-pipe"
34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune" 27 ALLOWED_FLAGS+=" -O -O1 -O2 -Os -mcpu -march -mtune"
35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all" 28 ALLOWED_FLAGS+=" -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking" 29 ALLOWED_FLAGS+=" -fbounds-checking -fno-strict-overflow"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time" 30 ALLOWED_FLAGS+=" -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+" 31 ALLOWED_FLAGS+=" -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident" 32 ALLOWED_FLAGS+=" -fno-ident -fpermissive"
40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w" 33 ALLOWED_FLAGS+=" -W* -w"
41 fi 34
42 # allow a bunch of flags that negate features / control ABI 35 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \ 36 ALLOWED_FLAGS+=" -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking" 37 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow \
38 -fno-omit-frame-pointer"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \ 39 ALLOWED_FLAGS+=" -mregparm -mno-app-regs -mapp-regs -mno-mmx -mno-sse \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \ 40 -mno-sse2 -mno-sse3 -mno-ssse3 -mno-sse4 -mno-sse4.1 -mno-sse4.2 \
41 -mno-avx -mno-aes -mno-pclmul -mno-sse4a -mno-3dnow -mno-popcnt \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \ 42 -mno-abm -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 -mplt \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \ 43 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \ 44 -mieee -mieee-with-inexact -mschedule -mfloat-gprs -mspe -mno-spe \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \ 45 -mtls-direct-seg-refs -mno-tls-direct-seg-refs -mflat -mno-flat \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \ 46 -mno-faster-structs -mfaster-structs -m32 -m64 -mx32 -mabi \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \ 47 -mlittle-endian -mbig-endian -EL -EB -fPIC -mlive-g0 -mcmodel \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \ 48 -mstack-bias -mno-stack-bias -msecure-plt -m*-toc -D* -U*"
54 -msecure-plt -D*"
55 49
56 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing 50 # 4.5
57 # NOTE: currently -Os have issues with gcc3 and K6* arch's 51 ALLOWED_FLAGS+=" -mno-fma4 -mno-movbe -mno-xop -mno-lwp"
58 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks" 52 # 4.6
53 ALLOWED_FLAGS+=" -mno-fsgsbase -mno-rdrnd -mno-f16c -mno-bmi -mno-tbm"
54
55 export ALLOWED_FLAGS
59 return 0 56 return 0
60} 57}
61 58
62# inverted filters for hardened compiler. This is trying to unpick 59# inverted filters for hardened compiler. This is trying to unpick
63# the hardened compiler defaults. 60# the hardened compiler defaults.
71 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie) 68 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
72 gcc-specs-pie || continue 69 gcc-specs-pie || continue
73 is-flagq -nopie || append-flags -nopie;; 70 is-flagq -nopie || append-flags -nopie;;
74 -fstack-protector) 71 -fstack-protector)
75 gcc-specs-ssp || continue 72 gcc-specs-ssp || continue
76 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;; 73 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
77 -fstack-protector-all) 74 -fstack-protector-all)
78 gcc-specs-ssp-to-all || continue 75 gcc-specs-ssp-to-all || continue
79 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;; 76 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
77 -fno-strict-overflow)
78 gcc-specs-nostrict || continue
79 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
80 esac 80 esac
81 done 81 done
82} 82}
83 83
84# Remove occurrences of strings from variable given in $1 84# Remove occurrences of strings from variable given in $1
85# Strings removed are matched as globs, so for example 85# Strings removed are matched as globs, so for example
86# '-O*' would remove -O1, -O2 etc. 86# '-O*' would remove -O1, -O2 etc.
87_filter-var() { 87_filter-var() {
88 local f x VAR VAL 88 local f x var=$1 new=()
89 declare -a new
90
91 VAR=$1
92 shift 89 shift
93 eval VAL=\${${VAR}} 90
94 for f in ${VAL}; do 91 for f in ${!var} ; do
95 for x in "$@"; do 92 for x in "$@" ; do
96 # Note this should work with globs like -O* 93 # Note this should work with globs like -O*
97 [[ ${f} == ${x} ]] && continue 2 94 [[ ${f} == ${x} ]] && continue 2
98 done 95 done
99 eval new\[\${\#new\[@]}]=\${f} 96 new+=( "${f}" )
100 done 97 done
101 eval export ${VAR}=\${new\[*]} 98 eval export ${var}=\""${new[*]}"\"
102} 99}
103 100
104# @FUNCTION: filter-flags 101# @FUNCTION: filter-flags
105# @USAGE: <flags> 102# @USAGE: <flags>
106# @DESCRIPTION: 103# @DESCRIPTION:
107# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs. 104# Remove particular <flags> from {C,CPP,CXX,CCAS,F,FC,LD}FLAGS. Accepts shell globs.
108filter-flags() { 105filter-flags() {
109 _filter-hardened "$@" 106 _filter-hardened "$@"
107 local v
108 for v in $(all-flag-vars) ; do
110 _filter-var CFLAGS "$@" 109 _filter-var ${v} "$@"
111 _filter-var CPPFLAGS "$@" 110 done
112 _filter-var CXXFLAGS "$@"
113 _filter-var FFLAGS "$@"
114 _filter-var FCFLAGS "$@"
115 return 0 111 return 0
116} 112}
117 113
118# @FUNCTION: filter-lfs-flags 114# @FUNCTION: filter-lfs-flags
119# @DESCRIPTION: 115# @DESCRIPTION:
120# Remove flags that enable Large File Support. 116# Remove flags that enable Large File Support.
121filter-lfs-flags() { 117filter-lfs-flags() {
122 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments" 118 [[ $# -ne 0 ]] && die "filter-lfs-flags takes no arguments"
119 # http://www.gnu.org/s/libc/manual/html_node/Feature-Test-Macros.html
120 # _LARGEFILE_SOURCE: enable support for new LFS funcs (ftello/etc...)
121 # _LARGEFILE64_SOURCE: enable support for 64bit variants (off64_t/fseeko64/etc...)
122 # _FILE_OFFSET_BITS: default to 64bit variants (off_t is defined as off64_t)
123 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 123 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
124} 124}
125 125
126# @FUNCTION: append-cppflags 126# @FUNCTION: append-cppflags
127# @USAGE: <flags> 127# @USAGE: <flags>
128# @DESCRIPTION: 128# @DESCRIPTION:
129# Add extra <flags> to the current CPPFLAGS. 129# Add extra <flags> to the current CPPFLAGS.
130append-cppflags() { 130append-cppflags() {
131 [[ -z $* ]] && return 0 131 [[ $# -eq 0 ]] && return 0
132 export CPPFLAGS="${CPPFLAGS} $*" 132 export CPPFLAGS="${CPPFLAGS} $*"
133 return 0
134}
135
136# @FUNCTION: append-cflags
137# @USAGE: <flags>
138# @DESCRIPTION:
139# Add extra <flags> to the current CFLAGS.
140append-cflags() {
141 [[ $# -eq 0 ]] && return 0
142 export CFLAGS=$(test-flags-CC ${CFLAGS} "$@")
143 return 0
144}
145
146# @FUNCTION: append-cxxflags
147# @USAGE: <flags>
148# @DESCRIPTION:
149# Add extra <flags> to the current CXXFLAGS.
150append-cxxflags() {
151 [[ $# -eq 0 ]] && return 0
152 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS} "$@")
133 return 0 153 return 0
134} 154}
135 155
136# @FUNCTION: append-fflags 156# @FUNCTION: append-fflags
137# @USAGE: <flags> 157# @USAGE: <flags>
138# @DESCRIPTION: 158# @DESCRIPTION:
139# Add extra <flags> to the current {F,FC}FLAGS. 159# Add extra <flags> to the current {F,FC}FLAGS.
140append-fflags() { 160append-fflags() {
141 [[ -z $* ]] && return 0 161 [[ $# -eq 0 ]] && return 0
142 export FFLAGS="${FFLAGS} $*" 162 export FFLAGS=$(test-flags-F77 ${FFLAGS} "$@")
143 export FCFLAGS="${FCFLAGS} $*" 163 export FCFLAGS=$(test-flags-FC ${FCFLAGS} "$@")
144 return 0 164 return 0
145} 165}
146 166
147# @FUNCTION: append-lfs-flags 167# @FUNCTION: append-lfs-flags
148# @DESCRIPTION: 168# @DESCRIPTION:
149# Add flags that enable Large File Support. 169# Add flags that enable Large File Support.
150append-lfs-flags() { 170append-lfs-flags() {
151 [[ -n $@ ]] && die "append-lfs-flags takes no arguments" 171 [[ $# -ne 0 ]] && die "append-lfs-flags takes no arguments"
172 # see comments in filter-lfs-flags func for meaning of these
152 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 173 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
153} 174}
154 175
155# @FUNCTION: append-flags 176# @FUNCTION: append-flags
156# @USAGE: <flags> 177# @USAGE: <flags>
157# @DESCRIPTION: 178# @DESCRIPTION:
158# Add extra <flags> to your current {C,CXX,F,FC}FLAGS. 179# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
159append-flags() { 180append-flags() {
160 [[ -z $* ]] && return 0 181 [[ $# -eq 0 ]] && return 0
161 export CFLAGS="${CFLAGS} $*" 182 append-cflags "$@"
162 export CXXFLAGS="${CXXFLAGS} $*" 183 append-cxxflags "$@"
163 export FFLAGS="${FFLAGS} $*" 184 append-fflags "$@"
164 export FCFLAGS="${FCFLAGS} $*"
165 return 0 185 return 0
166} 186}
167 187
168# @FUNCTION: replace-flags 188# @FUNCTION: replace-flags
169# @USAGE: <old> <new> 189# @USAGE: <old> <new>
170# @DESCRIPTION: 190# @DESCRIPTION:
171# Replace the <old> flag with <new>. Accepts shell globs for <old>. 191# Replace the <old> flag with <new>. Accepts shell globs for <old>.
172replace-flags() { 192replace-flags() {
173 [[ $# != 2 ]] \
174 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \ 193 [[ $# != 2 ]] && die "Usage: replace-flags <old flag> <new flag>"
175 && die "replace-flags takes 2 arguments, not $#"
176 194
177 local f fset 195 local f var new
178 declare -a new_CFLAGS new_CXXFLAGS 196 for var in $(all-flag-vars) ; do
179
180 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
181 # Looping over the flags instead of using a global 197 # Looping over the flags instead of using a global
182 # substitution ensures that we're working with flag atoms. 198 # substitution ensures that we're working with flag atoms.
183 # Otherwise globs like -O* have the potential to wipe out the 199 # Otherwise globs like -O* have the potential to wipe out the
184 # list of flags. 200 # list of flags.
201 new=()
185 for f in ${!fset}; do 202 for f in ${!var} ; do
186 # Note this should work with globs like -O* 203 # Note this should work with globs like -O*
187 [[ ${f} == ${1} ]] && f=${2} 204 [[ ${f} == ${1} ]] && f=${2}
188 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f} 205 new+=( "${f}" )
189 done 206 done
190 eval export ${fset}=\${new_${fset}\[*]} 207 eval export ${var}=\""${new[*]}"\"
191 done 208 done
192 209
193 return 0 210 return 0
194} 211}
195 212
223# @USAGE: <flag> 240# @USAGE: <flag>
224# @DESCRIPTION: 241# @DESCRIPTION:
225# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs. 242# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
226is-flagq() { 243is-flagq() {
227 [[ -n $2 ]] && die "Usage: is-flag <flag>" 244 [[ -n $2 ]] && die "Usage: is-flag <flag>"
228 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1 245
246 local var
247 for var in $(all-flag-vars) ; do
248 _is_flagq ${var} "$1" && return 0
249 done
250 return 1
229} 251}
230 252
231# @FUNCTION: is-flag 253# @FUNCTION: is-flag
232# @USAGE: <flag> 254# @USAGE: <flag>
233# @DESCRIPTION: 255# @DESCRIPTION:
289 311
290# @FUNCTION: strip-flags 312# @FUNCTION: strip-flags
291# @DESCRIPTION: 313# @DESCRIPTION:
292# Strip C[XX]FLAGS of everything except known good/safe flags. 314# Strip C[XX]FLAGS of everything except known good/safe flags.
293strip-flags() { 315strip-flags() {
294 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS 316 local x y var
295 317
296 setup-allowed-flags 318 setup-allowed-flags
297 319
298 local NEW_CFLAGS=""
299 local NEW_CXXFLAGS=""
300 local NEW_FFLAGS=""
301 local NEW_FCFLAGS=""
302
303 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
304 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
305 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
306 fi
307
308 set -f # disable pathname expansion 320 set -f # disable pathname expansion
309 321
310 for x in ${CFLAGS}; do 322 for var in $(all-flag-vars) ; do
323 local new=()
324
325 for x in ${!var} ; do
326 local flag=${x%%=*}
311 for y in ${ALLOWED_FLAGS}; do 327 for y in ${ALLOWED_FLAGS} ; do
312 flag=${x%%=*}
313 if [ "${flag%%${y}}" = "" ] ; then 328 if [[ -z ${flag%%${y}} ]] ; then
314 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 329 new+=( "${x}" )
315 break 330 break
316 fi 331 fi
317 done 332 done
318 done 333 done
319 334
320 for x in ${CXXFLAGS}; do
321 for y in ${ALLOWED_FLAGS}; do
322 flag=${x%%=*}
323 if [ "${flag%%${y}}" = "" ] ; then
324 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
325 break
326 fi
327 done
328 done
329
330 for x in ${FFLAGS}; do
331 for y in ${ALLOWED_FLAGS}; do
332 flag=${x%%=*}
333 if [ "${flag%%${y}}" = "" ] ; then
334 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
335 break
336 fi
337 done
338 done
339
340 for x in ${FCFLAGS}; do
341 for y in ${ALLOWED_FLAGS}; do
342 flag=${x%%=*}
343 if [ "${flag%%${y}}" = "" ] ; then
344 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
345 break
346 fi
347 done
348 done
349
350 # In case we filtered out all optimization flags fallback to -O2 335 # In case we filtered out all optimization flags fallback to -O2
351 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 336 if _is_flagq ${var} "-O*" && ! _is_flagq new "-O*" ; then
352 NEW_CFLAGS="${NEW_CFLAGS} -O2" 337 new+=( -O2 )
353 fi 338 fi
354 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 339
355 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 340 eval export ${var}=\""${new[*]}"\"
356 fi 341 done
357 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
358 NEW_FFLAGS="${NEW_FFLAGS} -O2"
359 fi
360 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
361 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
362 fi
363 342
364 set +f # re-enable pathname expansion 343 set +f # re-enable pathname expansion
365 344
366 export CFLAGS="${NEW_CFLAGS}"
367 export CXXFLAGS="${NEW_CXXFLAGS}"
368 export FFLAGS="${NEW_FFLAGS}"
369 export FCFLAGS="${NEW_FCFLAGS}"
370 return 0 345 return 0
371} 346}
372 347
373test-flag-PROG() { 348test-flag-PROG() {
374 local comp=$1 349 local comp=$1
375 local flags="$2" 350 local flag=$2
376 351
377 [[ -z ${comp} || -z ${flags} ]] && \ 352 [[ -z ${comp} || -z ${flag} ]] && return 1
378 return 1
379 353
354 # use -c so we can test the assembler as well
380 local PROG=$(tc-get${comp}) 355 local PROG=$(tc-get${comp})
381 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \ 356 ${PROG} "${flag}" -c -o /dev/null -xc /dev/null \
382 > /dev/null 2>&1 357 > /dev/null 2>&1
383} 358}
384 359
385# @FUNCTION: test-flag-CC 360# @FUNCTION: test-flag-CC
386# @USAGE: <flag> 361# @USAGE: <flag>
413 388
414 shift 389 shift
415 390
416 [[ -z ${comp} ]] && return 1 391 [[ -z ${comp} ]] && return 1
417 392
418 x=""
419 for x in "$@" ; do 393 for x in "$@" ; do
420 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}" 394 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
421 done 395 done
422 396
423 echo "${flags}" 397 echo "${flags}"
454# @USAGE: <flags> 428# @USAGE: <flags>
455# @DESCRIPTION: 429# @DESCRIPTION:
456# Short-hand that should hopefully work for both C and C++ compiler, but 430# Short-hand that should hopefully work for both C and C++ compiler, but
457# its really only present due to the append-flags() abomination. 431# its really only present due to the append-flags() abomination.
458test-flags() { test-flags-CC "$@"; } 432test-flags() { test-flags-CC "$@"; }
459
460# @FUNCTION: test_flag
461# @DESCRIPTION:
462# DEPRICIATED, use test-flags()
463test_flag() {
464 ewarn "test_flag: deprecated, please use test-flags()!" >&2
465
466 test-flags-CC "$@"
467}
468 433
469# @FUNCTION: test_version_info 434# @FUNCTION: test_version_info
470# @USAGE: <version> 435# @USAGE: <version>
471# @DESCRIPTION: 436# @DESCRIPTION:
472# Returns shell true if the current C compiler version matches <version>, else returns shell false. 437# Returns shell true if the current C compiler version matches <version>, else returns shell false.
492# @FUNCTION: get-flag 457# @FUNCTION: get-flag
493# @USAGE: <flag> 458# @USAGE: <flag>
494# @DESCRIPTION: 459# @DESCRIPTION:
495# Find and echo the value for a particular flag. Accepts shell globs. 460# Find and echo the value for a particular flag. Accepts shell globs.
496get-flag() { 461get-flag() {
497 local f findflag="$1" 462 local f var findflag="$1"
498 463
499 # this code looks a little flaky but seems to work for 464 # this code looks a little flaky but seems to work for
500 # everything we want ... 465 # everything we want ...
501 # for example, if CFLAGS="-march=i686": 466 # for example, if CFLAGS="-march=i686":
502 # `get-flag -march` == "-march=i686" 467 # `get-flag -march` == "-march=i686"
503 # `get-flag march` == "i686" 468 # `get-flag march` == "i686"
504 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do 469 for var in $(all-flag-vars) ; do
470 for f in ${!var} ; do
505 if [ "${f/${findflag}}" != "${f}" ] ; then 471 if [ "${f/${findflag}}" != "${f}" ] ; then
506 printf "%s\n" "${f/-${findflag}=}" 472 printf "%s\n" "${f/-${findflag}=}"
507 return 0 473 return 0
508 fi 474 fi
475 done
509 done 476 done
510 return 1 477 return 1
511}
512
513# @FUNCTION: has_hardened
514# @DESCRIPTION:
515# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
516has_hardened() {
517 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
518
519 test_version_info Hardened && return 0
520 # The specs file wont exist unless gcc has GCC_SPECS support
521 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
522}
523
524# @FUNCTION: has_pic
525# @DESCRIPTION:
526# DEPRECATED - use gcc-specs-pie from toolchain-funcs
527# indicate whether PIC is set
528has_pic() {
529 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
530
531 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
532 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
533 gcc-specs-pie
534}
535
536# @FUNCTION: has_pie
537# @DESCRIPTION:
538# DEPRECATED - use gcc-specs-pie from toolchain-funcs
539# indicate whether PIE is set
540has_pie() {
541 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
542
543 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
544 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
545 gcc-specs-pie
546}
547
548# @FUNCTION: has_ssp_all
549# @DESCRIPTION:
550# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
551# indicate whether code for SSP is being generated for all functions
552has_ssp_all() {
553 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
554
555 # note; this matches only -fstack-protector-all
556 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
557 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
558 gcc-specs-ssp-all
559}
560
561# @FUNCTION: has_ssp
562# @DESCRIPTION:
563# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
564# indicate whether code for SSP is being generated
565has_ssp() {
566 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
567
568 # note; this matches both -fstack-protector and -fstack-protector-all
569 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
570 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
571 gcc-specs-ssp
572} 478}
573 479
574# @FUNCTION: has_m64 480# @FUNCTION: has_m64
575# @DESCRIPTION: 481# @DESCRIPTION:
576# This doesn't test if the flag is accepted, it tests if the flag actually 482# This doesn't test if the flag is accepted, it tests if the flag actually
577# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works 483# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
578# return code is 0, else the return code is 1. 484# return code is 0, else the return code is 1.
579has_m64() { 485has_m64() {
486 eqawarn "${FUNCNAME}: don't use this anymore"
487
580 # this doesnt test if the flag is accepted, it tests if the flag 488 # this doesnt test if the flag is accepted, it tests if the flag
581 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 489 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
582 # please dont replace this function with test_flag in some future 490 # please dont replace this function with test_flag in some future
583 # clean-up! 491 # clean-up!
584 492
590 rm -f "${temp}".c 498 rm -f "${temp}".c
591 [[ ${ret} != 1 ]] && return 0 499 [[ ${ret} != 1 ]] && return 0
592 return 1 500 return 1
593} 501}
594 502
595# @FUNCTION: has_m32
596# @DESCRIPTION:
597# This doesn't test if the flag is accepted, it tests if the flag actually
598# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
599# code is 0, else return code is 1.
600has_m32() { 503has_m32() {
601 # this doesnt test if the flag is accepted, it tests if the flag 504 die "${FUNCNAME}: don't use this anymore"
602 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
603 # please dont replace this function with test_flag in some future
604 # clean-up!
605
606 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
607
608 local temp=$(emktemp)
609 echo "int main() { return(0); }" > "${temp}".c
610 MY_CC=$(tc-getCC)
611 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
612 local ret=$?
613 rm -f "${temp}".c
614 [[ ${ret} != 1 ]] && return 0
615 return 1
616} 505}
617 506
618# @FUNCTION: replace-sparc64-flags 507# @FUNCTION: replace-sparc64-flags
619# @DESCRIPTION: 508# @DESCRIPTION:
620# Sets mcpu to v8 and uses the original value as mtune if none specified. 509# Sets mcpu to v8 and uses the original value as mtune if none specified.
642 fi 531 fi
643 532
644 export CFLAGS CXXFLAGS 533 export CFLAGS CXXFLAGS
645} 534}
646 535
536# @FUNCTION: append-libs
537# @USAGE: <libs>
538# @DESCRIPTION:
539# Add extra <libs> to the current LIBS.
540append-libs() {
541 [[ $# -eq 0 ]] && return 0
542 local flag
543 for flag in "$@"; do
544 [[ ${flag} == -l* ]] && flag=${flag#-l}
545 export LIBS="${LIBS} -l${flag}"
546 done
547
548 return 0
549}
550
647# @FUNCTION: append-ldflags 551# @FUNCTION: append-ldflags
648# @USAGE: <flags> 552# @USAGE: <flags>
649# @DESCRIPTION: 553# @DESCRIPTION:
650# Add extra <flags> to the current LDFLAGS. 554# Add extra <flags> to the current LDFLAGS.
651append-ldflags() { 555append-ldflags() {
652 [[ -z $* ]] && return 0 556 [[ $# -eq 0 ]] && return 0
653 local flag 557 local flag
654 for flag in "$@"; do 558 for flag in "$@"; do
655 [[ ${flag} == -l* ]] && \ 559 [[ ${flag} == -l* ]] && \
656 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS" 560 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
657 done 561 done
668 _filter-var LDFLAGS "$@" 572 _filter-var LDFLAGS "$@"
669 return 0 573 return 0
670} 574}
671 575
672# @FUNCTION: raw-ldflags 576# @FUNCTION: raw-ldflags
673# @USAGE: <flags> 577# @USAGE: [flags]
674# @DESCRIPTION: 578# @DESCRIPTION:
675# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results 579# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
676# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed 580# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
677# to gcc where it needs the '-Wl,'. 581# to gcc where it needs the '-Wl,'.
582#
583# If no flags are specified, then default to ${LDFLAGS}.
678raw-ldflags() { 584raw-ldflags() {
679 local x input="$@" 585 local x input="$@"
680 [[ -z ${input} ]] && input=${LDFLAGS} 586 [[ -z ${input} ]] && input=${LDFLAGS}
681 set -- 587 set --
682 for x in ${input} ; do 588 for x in ${input} ; do
684 set -- "$@" ${x//,/ } 590 set -- "$@" ${x//,/ }
685 done 591 done
686 echo "$@" 592 echo "$@"
687} 593}
688 594
689# @FUNCTION: bindnow-flags 595# @FUNCTION: no-as-needed
690# @RETURN: Returns the flags to enable "now" binding in the current selected linker. 596# @RETURN: Flag to disable asneeded behavior for use with append-ldflags.
691# @DESCRIPTION: 597no-as-needed() {
692# DEPRECATED - Gets the flags needed for "NOW" binding
693bindnow-flags() {
694 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild" >&2
695
696 case $($(tc-getLD) -v 2>&1 </dev/null) in 598 case $($(tc-getLD) -v 2>&1 </dev/null) in
697 *GNU* | *'with BFD'*) # GNU ld 599 *GNU*) # GNU ld
698 echo "-Wl,-z,now" ;; 600 echo "-Wl,--no-as-needed" ;;
699 *Apple*) # Darwin ld
700 echo "-bind_at_load" ;;
701 *)
702 # Some linkers just recognize -V instead of -v
703 case $($(tc-getLD) -V 2>&1 </dev/null) in
704 *Solaris*) # Solaris accept almost the same GNU options
705 echo "-Wl,-z,now" ;;
706 esac
707 ;;
708 esac 601 esac
709} 602}
710 603
711 604fi
712# Some tests for when we screw with things and want to make
713# sure we didn't break anything
714#TESTS() {
715# CFLAGS="-a -b -c=1"
716# CXXFLAGS="-x -y -z=2"
717# LDFLAGS="-l -m -n=3"
718#
719# die() { exit 1; }
720# (is-flag 1 2 3) && die
721# (is-ldflag 1 2 3) && die
722#
723# is-flagq -l && die
724# is-ldflagq -a && die
725# is-flagq -a || die
726# is-flagq -x || die
727# is-ldflagq -n=* || die
728# is-ldflagq -n && die
729#
730# strip-unsupported-flags
731# [[ ${CFLAGS} == "-c=1" ]] || die
732# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
733#
734# echo "All tests pass"
735#}
736#TESTS

Legend:
Removed from v.1.124  
changed lines
  Added in v.1.169

  ViewVC Help
Powered by ViewVC 1.1.20